#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h> 
#include <sys/socket.h>
#include <netinet/in.h>
#include <fcntl.h>
#include <unistd.h>

#define MAX_BUFF 4096


int main(int argc, char *argv[]) {

	int sockfd, clisock, portno, clilen, n, fd, written, tmp;
	char *buf = (char *) malloc(MAX_BUFF*sizeof(char));

	struct sockaddr_in serv_addr;

	if (argc < 3) {
		perror("parameters: <server IP> <server PORT>");
		exit(1);
 	}


	sockfd = socket(PF_INET,SOCK_STREAM,0);

	if(sockfd<0) {
		perror("ERROR on socket");
 	}


	bzero((char *) &serv_addr, sizeof(serv_addr));

	serv_addr.sin_family = AF_INET;
	if(inet_pton(AF_INET, argv[1], &serv_addr.sin_addr) == 0){
		perror("Malformed IP ADDRESS");
		exit(1);
	}

	portno = atoi(argv[2]);
	if(portno == 0){
		perror("Invalid port");
		exit(1);
	}
	
	serv_addr.sin_port = htons(portno);
	printf("port: %d\n", portno);
	
	if (connect(sockfd, (struct sockaddr *)&serv_addr, sizeof(struct sockaddr)) < 0){
 		perror("connect");
 		exit(1);
 	}
 
	printf("connected now sending file\n");

	fd = open("a1.txt", O_RDONLY);
	
    
	if (fd<0){
 		perror("ERROR opening file");
 		exit(1);
 	}


	while((n = read(fd, buf, MAX_BUFF)) > 0) {
		written = 0;	
	    while(written < n) {
	    	if((tmp = write(sockfd, buf+written, n-written)) < 0){
	    		perror("error on write");
	    		break;
	    	}
	    	written += tmp;
	    }
	}


	printf("\n closing connection and file \n");
	free(buf);
	close(sockfd);
	close(fd);

	return 0;
}


 
 