#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h> 
#include <sys/socket.h>
#include <netinet/in.h>


#define MAX_BUFF 4096
#define MAX_PENDING 5

int main(int argc, char *argv[]) {
	int sockfd, clisock, portno, clilen, n, bytes_read, written;
	char *buf = (char *) malloc(MAX_BUFF*sizeof(char));

//struct sockaddr_in is specific for the internet
	struct sockaddr_in serv_addr, cli_addr;
	struct sockaddr serv, cli;

	if (argc <2) {
	 perror("PORT # MISSING");
	 exit(1);
 	}



	sockfd = socket(PF_INET,SOCK_STREAM,0);

	if(sockfd<0) {
		perror("ERROR on socket");
		exit(1);
 	}

	bzero((char *) &serv_addr, sizeof(serv_addr));


	portno = atoi(argv[1]);
	if(portno == 0){
		perror("Invalid port");
		exit(1);
	}

	//debug 1
	printf("port: %d\n", portno);

	//what is the limitation of AF_INET?
	serv_addr.sin_family = AF_INET;
	serv_addr.sin_addr.s_addr = INADDR_ANY;
	
	
	// port inside the server, why htons? 
	serv_addr.sin_port = htons(portno);

	if(bind(sockfd, (struct sockaddr *) &serv_addr, sizeof(serv_addr))<0) {
		perror("ERROR on bind()");
		exit(1);
	}

	//debug 2
	printf("bind successful\n");

    //where are the pending connections stored?
	listen(sockfd, MAX_PENDING);


	//debug 2a
	printf("listen successful\n");

	while(1) {

		clilen = sizeof(cli_addr);
		
		//why is there a cast to a sockaddr?
		//why is clilen a pointer?
		//when will accept return?
 		clisock = accept(sockfd, (struct sockaddr *) &cli_addr, &clilen);
 		
 		//when will accept return?
 		printf("new connection has arrived!\n");

 		if (clisock < 0) {
			perror("ERROR on accept()");
			//is this sufficient error checking?
			close(clisock);
			continue;
		}

		printf("accept successful: %d\n", clisock);



		//why do we need a while loop here?
 		while(1) {
 			n = read(clisock, buf, MAX_BUFF);
	    	if (0 == n) {
	    		break;
	    	}
	    	else if(n<0) {
	    		perror("ERROR on read"); 
	    		close(clisock); 
	    		break;
	    	}
	    	
	    	
	    	while(n < MAX_BUFF) {
	    		n += read(clisock, buf + n , MAX_BUFF - n);
	    	}
	    	//what is the limitation of the following?
	    	//buf[n] = '\0';
	    	//printf("%s", buf);
	    	
	    	//why loop here is necessary
	     	written = 0;	
	    	while(written < n) {
	    		written += write(1, buf+written, n-written);
	    	}
  		}
  		
  		printf("\n");
		
 		close(clisock);
 	} // end while

	close(sockfd);
	free(buf);

	return 0;
} // end main
